/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2020                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#include "blade-config.h"
#include "BladeUtils.h"

QString 
BladeUtils::shortCutRegionName(const QString & original) 
{
    if (original.length() > BladeUtils::maxRegionName)
    {
        QString to_return = original.left(BladeUtils::startLength) + "..." + original.right(BladeUtils::endLength);
        return to_return;
    }
    else
        return original;
}

std::string 
BladeUtils::shortCutRegionName(const std::string & original) 
{
    if (original.size() > BladeUtils::maxRegionName)
    {
        std::string to_return = original.substr(0,BladeUtils::startLength) + "..." + original.substr( original.size()- BladeUtils::endLength - 1 );
        return to_return;
    }
    else
        return original;
}
