/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2020                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#include "blade-config.h"
#include <cmath>
#include <iostream>
#include <limits>
#include "CallLevelFilter.h"


CallLevelFilter::CallLevelFilter( )
{
    level = -1;
}


void
CallLevelFilter::set_call_level( int32_t _l  )
{
    level = _l;
}


FilterResult 
CallLevelFilter::apply( TraceEvent * _te )
{
    if (!is_active())
        return FILTER_OK;
    if (level == -1)
	return FILTER_OK;
    
    if (_te->get_level() > level)
	return FILTER_FAIL;
    
    return FILTER_OK;
}
    
