/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2020                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#include "blade-config.h"
#include "CallPathFilter.h"

void
CallPathFilter::set_call_path( uint32_t _cp, bool _is_expanded)
{
    callpath = _cp;
    exclusive = _is_expanded;
}

    
FilterResult 
CallPathFilter::apply( TraceEvent * _te )
{ 
    if (!is_active())
        return FILTER_OK;
    
    FilterResult result = FILTER_CHILDREN;
    TraceEvent * _p = _te;
    
    if (exclusive)
    {
        if (_p != NULL && _p->get_parent()->get_callpath() == callpath)
            return FILTER_DIRECT_CHILDREN;
    }
    
    
    while ( _p->get_parent() != NULL)
    {
        if ( _p->get_callpath() == callpath )
        {
            result = FILTER_OK;
            break;
        }
        _p= _p->get_parent();
    }
    return result;
}
    
