/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2020                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#include "blade-config.h"
#include "ZoomLeaveFilter.h"


 
FilterResult 
ZoomLeaveFilter::apply( TraceEvent * _te )
{
    if (!is_active())
        return FILTER_OK;
    
    uint64_t start_window = zoom.back().first;
    uint64_t end_window = zoom.back().second; 
    if (_te->get_end_timestamp() < start_window )
        return FILTER_FAIL;
    
    return FILTER_OK;
    
}
