/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2020                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef __DIRECT_METRIC_EVALUATION_CPP
#define __DIRECT_METRIC_EVALUATION_CPP 0

#include "blade-config.h"
#include "DirectMetricEvaluation.h"
#include "Trace.h"
extern Trace * trace;

// using namespace cube;

DirectMetricEvaluation::DirectMetricEvaluation( std::string _n)
{
    metric_uniq_name = _n;
    index = ((size_t)-1)-1;
    if (_n.compare("time")!=0)
    {
        index = trace->get_metric_index(_n);
    }
};


DirectMetricEvaluation::~DirectMetricEvaluation()
{
}


TraceEventStrippedSection
DirectMetricEvaluation::eval( TraceEventSection& _input)
{
    TraceEventStrippedSection _s = _input.get_stripped_section( index );
    return _s;
};


#endif
