/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2020                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#include "blade-config.h"
#include <string>
#include <vector>
#include <inttypes.h>

#include "RecvP2PTraceEvent.h"
#include "IRecvP2PTraceEvent.h"

#include "ISendP2PTraceEvent.h"
     
bool
ISendP2PTraceEvent::match( P2PTraceEvent * _e) const
{
    RecvP2PTraceEvent * _as_recv =dynamic_cast<RecvP2PTraceEvent*>(_e);
    IRecvP2PTraceEvent * _as_irecv = dynamic_cast<IRecvP2PTraceEvent*>(_e);

    if (_as_recv != NULL)
        return AsyncP2PTraceEvent::match( _as_recv->get_tag(), _as_recv->get_location(), _as_recv->get_communicator()   );
    if (_as_irecv != NULL)
        return AsyncP2PTraceEvent::match( _as_irecv->get_tag(), _as_irecv->get_location(), _as_irecv->get_communicator()   );
    return false;
    
}
    
    
    
