/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2018                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef __DEFAULT_FILTER_RULE_H
#define __DEFAULT_FILTER_RULE_H 0

#include "FilterRule.h"

namespace scorepion_plugin
{
    namespace filters
    {
        class DefaultFilterRule : public FilterRule
        {
        public:
            DefaultFilterRule() : FilterRule("*") {};
            DefaultFilterRule( const std::string & _val ) : FilterRule( _val ) {};
            virtual
            ~DefaultFilterRule() {};
            
            virtual 
            std::string extract_string(const cube::Vertex * _c ) const
            {
                std::string _n = "";    
                const cube::Cnode * _cnode = dynamic_cast<const cube::Cnode*>( _c );
                if (_cnode != NULL) // callpath
                {
                    _n = _cnode->get_callee()->get_mod();
                }
                else
                {
                    const cube::Region * _region = dynamic_cast<const cube::Region*>( _c );
                    if (_region != NULL) // region
                    {
                        _n = _region->get_mod();
                    }
                }
                return _n;
            }
            
            
            virtual
            FilterResult
            apply(cube::Vertex * _v) const
            {
                bool result = match_rule( _v );
                return (result)?INCLUDE:NO_MATCH;
            }

            

        };
    }
 };

#endif
