/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef __FILTER_RULE_H
#define __FILTER_RULE_H 0

#include <sys/types.h>
#include <string>
#include <Cube.h>


namespace scorepion_plugin
{
    namespace filters
    {
        
       enum FilterResult { INCLUDE=0, EXCLUDE=1, NO_MATCH=2 };
        
     
        
        class FilterRule
        {
        protected:
            std::string regex;
            
            
            std::string 
            adjust( const std::string & );
            
            void
            wildcard_replace(std::string & _v, char from, char to) const;
        
        public:
            FilterRule() : regex("") {};
            FilterRule( const std::string & );
            virtual
            ~FilterRule() {};

             
            virtual
            FilterResult
            apply(cube::Vertex *) const;
            
            
            bool
            match_rule(cube::Vertex *) const;
            
            
            virtual 
            std::string extract_string(const cube::Vertex *  ) const  {return ""; };
            
            bool
            match_regex( const std::string & ) const ;
            
            bool
            ignore_filtering( cube::Vertex * ) const ;
                        
            
            virtual
            void
            print( std::ostream & out, bool intel);

        };
    }
 };

#endif
