/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef __FILTERS_CHAIN_H
#define __FILTERS_CHAIN_H 0

#include <FilterRulesSet.h>
#include <list>

namespace scorepion_plugin
{
    namespace filters
    {
        

        
        class FiltersChain
        {
        protected:
            std::list<FilterRulesSet*> sets;
        public:
            FiltersChain() ;
            ~FiltersChain() ;

            
            void
            clear()
            {
                sets.clear();
            }
            
            
            FilterResult
            apply(cube::Vertex *) const;
            
           
            inline
            void 
            addSet( FilterRulesSet * _set)
            {
                sets.push_back( _set);
            }
               
            
            void
            print( std::ostream & out) const;
            
            
            std::ostream& 
            operator<< (std::ostream&) const;

        };
    }
 };

#endif
