/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef __INCLUDE_FILE_FILTER_RULES_SET_H
#define __INCLUDE_FILE_FILTER_RULES_SET_H 0

#include <vector>
#include "FilterRulesSet.h"
#include "IncludeRegionFileFilterRule.h"

namespace scorepion_plugin
{
    namespace filters
    {
        class IncludeFileFilterRulesSet : public FilterRulesSet
        {
            public:
                IncludeFileFilterRulesSet(): FilterRulesSet(INCLUDE_FILE) {match_result = INCLUDE;};
                virtual
                ~IncludeFileFilterRulesSet() {};
                
                virtual
                void
                AddRule(  const std::string & rule) 
                {
                    FilterRulesSet::AddRule( new IncludeRegionFileFilterRule( rule ));
                }
                
/*
                virtual 
                void
                print(std::ostream& ) const;
  
                friend
                std::ostream& 
                operator<< (std::ostream&, const IncludeFileFilterRulesSet&);*/
            
        };
    }
 };

#endif
